// Marcelo Eiji Morioka
// Marcos Tatsuo Yamamoto
// Geometria Computacional
// Prof. Coelho
// Linguagem utilizada: Java (jdk 1.1.6)

import java.lang.*;
import java.io.*;
import AVLTree;
import java.util.*;

public class InterSegmentos {	
    static AVLTree arvore;
    static AVLTree filaEventos;
    static Vector v;
    static int contador;

    // construtor
    public InterSegmentos(Vector vetor) {
	int xp, xq;
	Segmento s;
	arvore = new AVLTree();
	filaEventos = new AVLTree();
	v = vetor;
	xp = 0;
	xq = 0;
	contador = 0;

	for (int i=0; i<(v.size()-1); i+=2) {
	    Ponto p = (Ponto)(v.elementAt(i));
	    Ponto q = (Ponto)(v.elementAt(i+1));
	    xp = ((Ponto)v.elementAt(i)).getX();
	    xq = ((Ponto)v.elementAt(i+1)).getX();
	    if (xp < xq) {
		s = new Segmento(p,q, i);
	    }
	    else
		s = new Segmento(q,p, i);
	    filaEventos.put(xp, p, 1, 0);
	    filaEventos.put(xq, q, 1, 0);
	    p.setSegment(s);
	    q.setSegment(s);
	}
    }
    
    
    // funcao que verifica se dois segmentos se interceptam ou no
    static boolean Cruza(Segmento s1, Segmento s2) {
	Ponto p1i, p1f, p2i, p2f;

	if (s1!=null && s2!=null) {
	    contador++;
	    p1i = s1.getFirst();
	    p1f = s1.getLast();
	    p2i = s2.getFirst();
	    p2f = s2.getLast();
	    
	    if ((p1i.getY() > p2i.getY() && p1f.getY() < p2f.getY()) ||
		(p1i.getY() < p2i.getY() && p1f.getY() > p2f.getY())) 
		if (!(p1i.getX() < p2i.getX() && p1i.getX() < p2f.getX() &&
		      p1f.getX() < p2i.getX() && p1f.getX() < p2f.getX()))
		    if (((s1.Orientacao(s2.getFirst()) > 0) && (s1.Orientacao(s2.getLast()) < 0)) ||
			((s1.Orientacao(s2.getFirst()) < 0) && (s1.Orientacao(s2.getLast()) > 0)))
			if (((s2.Orientacao(s1.getFirst()) > 0) && (s2.Orientacao(s1.getLast()) < 0)) ||
			    ((s2.Orientacao(s1.getFirst()) < 0) && (s2.Orientacao(s1.getLast()) > 0)))
			    return (true);
	}
	return false;
    }
    
    static Ponto CalculaInterseccao(Segmento s1, Segmento s2) {
	double ms1, ms2, bs1, bs2, px, py;
	Ponto p;
	
	ms1 = (double)((s1.getLast()).getY() - (s1.getFirst()).getY())/((s1.getLast()).getX() - (s1.getFirst()).getX());

	ms2 = (double)((s2.getLast()).getY() - (s2.getFirst()).getY())/((s2.getLast()).getX() - (s2.getFirst()).getX());

	bs1 = (double)(- ms1*(s1.getFirst()).getX() + (s1.getFirst()).getY());
	bs2 = (double)(- ms2*(s2.getFirst()).getX() + (s2.getFirst()).getY());

	px = (bs1 - bs2)/(ms2 - ms1);
	py = (bs1*ms2 - bs2*ms1)/(ms2 - ms1);
	p = new Ponto((int)(px + 1), (int)(py + 1));

	p.setSegment(s1);
	p.setSegment2(s2);
	//	System.out.println(px+" "+py);
	//	System.out.println(s1.getKey()+" "+s2.getKey());

	return(p);
    }

    static Vector Verifica() {
	int i;
	Ponto p, p1, p2, pa, pInter;
	Segmento s, s1, s2;
	Segmento vizup, vizdown;
	Vector vec = new Vector();
	boolean cruza;
	
	// para cada ponto da arvore
	for (p = (Ponto)filaEventos.min(); (p != null); p = (Ponto)filaEventos.min()) {
	    s = p.getSegment();
	    //	    System.out.println(p.getX()+" "+ p.getY()+" "+s.getKey());
	    //	    System.out.println(arvore.toString());
	    // se p eh extremo esquerdo do segmento S
	    if (p == s.getFirst()) {
		arvore.put(s.getKey(), s, 0, p.getX());
		vizup = arvore.VizinhoAcima(s, p.getX());
		vizdown = arvore.VizinhoAbaixo(s, p.getX());
		if (Cruza(s, vizup)) {
		    vec.addElement(s);
		    vec.addElement(vizup);
		    pInter = CalculaInterseccao(vizup, s);
		    filaEventos.put(pInter.getX(), pInter, 1, 0);
		}
		if (Cruza(s, vizdown)) {
		    vec.addElement(s);
		    vec.addElement(vizdown);
		    pInter = CalculaInterseccao(s, vizdown);
		    filaEventos.put(pInter.getX(), pInter, 1, 0);
		}
	    }
	    // se p eh extremo direito do segmento S
	    else {
		if (p==s.getLast()) {
		    vizup = arvore.VizinhoAcima(s, p.getX()-1);
		    vizdown = arvore.VizinhoAbaixo(s, p.getX()-1);
		    if (Cruza(vizup,vizdown)) {
			vec.addElement(vizup);
			vec.addElement(vizdown);
			pInter = CalculaInterseccao(vizup, vizdown);
			filaEventos.put(pInter.getX(), pInter, 1, 0);
		    }
		    arvore.remove(s.getKey(), s, 0, p.getX());
		}
		// p eh ponto de interseccao
		else {
		    //		    System.out.println("Inter");
		    s2 = p.getSegment2();
		    vizup = arvore.VizinhoAcima(s, p.getX()-2);
		    vizdown = arvore.VizinhoAbaixo(s2, p.getX()-2);
		    /*		    System.out.println(s.getKey()+" "+s2.getKey());
				    if (vizup != null)
				    System.out.println("up "+vizup.getKey());
				    if (vizdown != null)
				    System.out.println("down "+vizdown.getKey());*/
		    if (Cruza(s2, vizup)) {
			vec.addElement(s2);
			vec.addElement(vizup);
			pInter = CalculaInterseccao(vizup, s2);
			filaEventos.put(pInter.getX(), pInter, 1, 0);
		    }
		    if (Cruza(s, vizdown)) {
			vec.addElement(s);
			vec.addElement(vizdown);
			pInter = CalculaInterseccao(s, vizdown);
			filaEventos.put(pInter.getX(), pInter, 1, 0);
		    }
		    //		    System.out.println("removendo");
		    arvore.remove(s.getKey(), s, 0, p.getX()-2);
		    //		    System.out.println(arvore.toString());
		    arvore.remove(s2.getKey(), s2, 0, p.getX()-2);
		    //		    System.out.println(arvore.toString());
		    arvore.put(s2.getKey(), s2, 0, p.getX()+2);
		    //		    System.out.println(arvore.toString());
		    arvore.put(s.getKey(), s, 0, p.getX()+2);
		    //		    System.out.println(arvore.toString());
		}
	    }
	}
	return vec;
    }

    public int getContador() {
	return contador;
    }
}





