// Marcelo Eiji Morioka
// Marcos Tatsuo Yamamoto
// Geometria Computacional
// Prof. Coelho
// Linguagem utilizada: Java (jdk 1.1.6)

import java.lang.*;
import java.io.*;
import java.util.*;

public class InterSegmentosBurro {	
    static AVLTree arvore;
    static AVLTree filaEventos;
    static Vector v, vSeg;
    static int contador;

    // construtor
    public InterSegmentosBurro(Vector vetor) {
	int xp, xq;
	Segmento s;
	arvore = new AVLTree();
	filaEventos = new AVLTree();
	v = vetor;
	contador = 0;
	// Vetor de Segmentos
	vSeg = new Vector(); 
	
	for (int i=0; i<(v.size()-1); i+=2) {
	    Ponto p = (Ponto)(v.elementAt(i));
	    Ponto q = (Ponto)(v.elementAt(i+1));
	    xp = ((Ponto)v.elementAt(i)).getX();
	    xq = ((Ponto)v.elementAt(i+1)).getX();
	    if (xp < xq)
		s = new Segmento(p,q, i);
	    else
		s = new Segmento(q,p, i);

	    vSeg.addElement(s);
	    p.setSegment(s);
	    q.setSegment(s);

	}
    }
    
    // funcao que verifica se dois segmentos se interceptam ou no
    static boolean Cruza(Segmento s1, Segmento s2) {
	Ponto p1i, p1f, p2i, p2f;

	if (s1!=null && s2!=null) {
	    contador++;
	    p1i = s1.getFirst();
	    p1f = s1.getLast();
	    p2i = s2.getFirst();
	    p2f = s2.getLast();
	    
	    if ((p1i.getY() > p2i.getY() && p1f.getY() < p2f.getY()) ||
		(p1i.getY() < p2i.getY() && p1f.getY() > p2f.getY())) 
		if (!(p1i.getX() < p2i.getX() && p1i.getX() < p2f.getX() &&
		      p1f.getX() < p2i.getX() && p1f.getX() < p2f.getX()))
		    if (((s1.Orientacao(s2.getFirst()) > 0) && (s1.Orientacao(s2.getLast()) < 0)) ||
			((s1.Orientacao(s2.getFirst()) < 0) && (s1.Orientacao(s2.getLast()) > 0)))
			if (((s2.Orientacao(s1.getFirst()) > 0) && (s2.Orientacao(s1.getLast()) < 0)) ||
			    ((s2.Orientacao(s1.getFirst()) < 0) && (s2.Orientacao(s1.getLast()) > 0)))
			    return (true);
	}
	return false;
    }
    
    static Vector Verifica() {
	int i, j;
	Ponto p, p1, p2, pa;
	Segmento s, s1, s2;
	Segmento vizup, vizdown;
	Vector vec = new Vector();
	boolean cruza;
	
	// Para todos os segmentos
	for (i = 0; i < vSeg.size() - 1; i++) {
	    for (j = i + 1; j < vSeg.size(); j++) {
		s1 = (Segmento)vSeg.elementAt(i);
		s2 = (Segmento)vSeg.elementAt(j);
		if (Cruza(s1,s2)) {
		    vec.addElement(s1);
		    vec.addElement(s2);
		}
	    }
	} 

	return vec;
    }

    public int getContador() {
	return contador;
    }

}
